require 'shellwords'

module Netfira
  class InstallerGenerator
    class Binary

      def self.available?
        @available = !bin_file.nil?
      end

      def self.bin_file
        @bin_file = bin_files.select{ |file| system "which #{file} > /dev/null" }.first
      end

      def run(output_device = :null)
        system "#{command} > /dev/#{output_device}"
      end

      def esc(string)
        Shellwords.escape string
      end

    end
  end
end

require_relative 'binary/makensis'
require_relative 'binary/signcode'
